<div class="game-loader">
  {#if errored}
  <div class="loader-error">
    <div class="loader-text">
      An error occurred while executing that game!
      You should probably report this to the developer!
    </div>
  </div>
  {:else}
  <canvas ref:canvas
          on:mousedown="dispatchEvent('mousedown', [event.pageX - this.offsetTop, event.pageY - this.offsetLeft], stateId)"
          on:mousemove="dispatchEvent('mousemove', [event.pageX - this.offsetTop, event.pageY - this.offsetLeft], stateId)"
          on:mouseup="dispatchEvent('mouseup', [event.pageX - this.offsetTop, event.pageY - this.offsetLeft], stateId)" />
  {/if}
</div>


<script>import RestClient from "../../js/RestClient";
  import env from "../../js/constants";

  let cachedWorker = new Worker("../../lualibs/harmonysdk.js");
  let stateCounter = 0;
  const paths = new Map();
  
  export default {
    oncreate() {
      this.ensureWorker();
      this.drawingContext = this.refs.canvas.getContext("2d");
      this.cacheCanvas = document.createElement("canvas");
      this.cacheContext = this.cacheCanvas.getContext("2d");
      this.gameSessions = new Map();
    },
    onupdate({changed, current}) {
      this.ensureWorker();
      if (!current.errored && changed.gameId) {
        this.loadGame(current.gameId, current.options);
      }
    },
    methods: {
      dispatchEvent(eventName, args, stateId = null) {
        console.log("disptchEvent", eventName);
        this.worker.postMessage({
          source: "renderer",
          destination: "gameworker",
          type: "event",
          eventName: eventName,
          stateId,
          args: args
        });
      },
      ensureWorker() {
        if (!this.worker) {
          this.worker = cachedWorker;
          this._messageListener = ev => {
            console.log("Message received from gameworker!", ev);
            if (
              ev.data.source == "gameworker" &&
              ev.data.destination == "renderer" &&
              this.get().stateId == ev.data.stateId
            ) {
              console.log("Message checks out", ev.data.type);
              if (ev.data.type == "command") {
                if (ev.data.action == "createPath") {
                  const pathList = paths.get(ev.data.stateId);
                  const path = new Path2D();
                  pathList.set(ev.data.data[0], path);
                } else if (ev.data.action == "respond") {
                  this.fire("setGame", {
                    game: this.gameSessions.get(ev.data.stateId),
                    options: String(ev.data.data[0])
                  });
                } else if (ev.data.action == "drawImage") {
                  const relativePath = ev.data.data[0];
                  const game = this.gameSessions.get(ev.data.stateId);
                  const urlObject = new URL("https://example.org");
                  urlObject.pathname = relativePath;
                  const fullUrl = urlObject.href.replace(
                    "https://example.org",
                    env.API_BASE + "/games/" + game.id + "/assets"
                  );
                  ev.data.data[0] = new Image(fullUrl);
                  ev.data.data[0].addEventListener("load", () => {
                    this.drawingContext[ev.data.action].apply(
                      this.drawingContext,
                      ev.data.data
                    );
                  });
                } else if (ev.data.action.startsWith("path")) {
                  const pathList = paths.get(ev.data.stateId);
                  const path = pathList.get(ev.data.data.shift());
                  const action = path[ev.data.action.substring(4)];
                  action.apply(path, ev.data.data);
                } else {
                  console.log("firing", this.drawingContext[ev.data.action]);
                  this.drawingContext[ev.data.action].apply(
                    this.drawingContext,
                    ev.data.data
                  );
                }
              }
            }
          };
          this.worker.addEventListener("message", this._messageListener);
        }
      },
      async loadGame(gameId, options) {
        this.drawingContext.clearRect(
          0,
          0,
          this.refs.canvas.width,
          this.refs.canvas.height
        );

        const stateId = stateCounter++;

        const game = await RestClient.get(`/games/${gameId}`);

        this.gameSessions.set(stateId, game);
        this.set({stateId});

        this.worker.postMessage({
          source: "renderer",
          destination: "gameworker",
          type: "action",
          actionName: "create",
          stateId,
          code: game.code
        });
        this.dispatchEvent(
          "load",
          [this.refs.canvas.height, this.refs.canvas.width, options],
          stateId
        );
      }
    }
  };
</script>

<style>
  .game-loader {
    margin: 0 0.25em;
  }
</style>
